import numpy as np
import scipy.signal as signal
import matplotlib.pyplot as plt

fp=1e3
fs=2e3
Ap=0.5
As=60
ws=2*np.pi*fs
wp=2*np.pi*fp

#N,Wn=signal.buttord(wp, ws, Ap, As, analog=True)
#N,Wn=signal.cheb1ord(wp, ws, Ap, As, analog=True)
N,Wn=signal.ellipord(wp, ws, Ap, As, analog=True)

print "Order",N
print "Normalization frequency",Wn/(2*np.pi)

#b,a=signal.butter(N,Wn,"lowpass",analog=True,output="ba")
#b,a=signal.cheb1(N,Ap,Wn,"lowpass",analog=True,output="ba")
b,a=signal.ellip(N,Ap,As,Wn,"lowpass",analog=True,output="ba")



w,mdb,p=signal.bode((b,a), n=10000)

#p=180/np.pi*np.unwrap(p/180*np.pi)
#p=np.unwrap(p/180*np.pi)
p=p/180*np.pi
plt.semilogx(w/(2*np.pi),mdb)
plt.title("Magnitude (dB) response")
plt.show()

plt.semilogx(w/(2*np.pi),p)
plt.title("Phase response")
plt.show()

t,y=signal.step((b,a))

plt.plot(t,y)
plt.title("Step response")
plt.show()

t1=np.linspace(0,0.020,1000)

y1=np.sin(2*np.pi*t1*1000)
#y1=y1+0.5*(np.random.random(t1.shape)-0.5)
y1=y1+2*np.sin(2*np.pi*t1*2e3)

plt.plot(t1,y1)
plt.title("sum of 1 kH and 2 kHz sinusoids")
plt.show()

yf=signal.lsim((b,a),y1,t1)
plt.plot(yf[0],yf[1],label="filtered")
plt.plot(t1,y1,label="unfiltered")
plt.legend()
plt.title("Effect of filter")
plt.show()
