import numpy as np
import scipy as sp
import matplotlib.pyplot as plt
import scipy.signal as signal
import matplotlib as mpl

mpl.rc('xtick', labelsize=16)
mpl.rc('ytick', labelsize=16)
mpl.rc("axes",labelsize=18)
#
# Computes the frequency response (magnitude) and step response of
# a generic first order H(z)
#
##Legend:
##            b1*z + b0
##    H(z) = --------------
##             a1*z + a0

b1=0.5
b0=0
a1=1+0.5
a0=-1

fs=1
T=1.0/fs

bz2=np.array([b1,b0])
az2=np.array([a1,a0])

wz2,pz2=signal.freqz(bz2,az2) # Freq response
tz2,yz2=signal.dstep([bz2,az2,T],n=100) # Step response

# Plots of the frequency response and impulse response


plt.loglog(wz2/2/np.pi*fs,abs(pz2))

plt.show()


plt.plot(tz2,yz2[0])

plt.show()
